SystemOrganization addCategory: #'Multilingual-ImmPlugin'!

Object subclass: #ImmAbstractPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-ImmPlugin'!

!ImmAbstractPlatform commentStamp: 'LaurentLaffont 3/15/2011 20:48' prior: 0!
I provide an abstract interface for providing feedback needed by the OS for doing correct multilingual input/output.

Precomposition is done for countries  (Japan, Korea ) where keyboards have phonetic characters which are combined to create actual ideographic characters, which are then sent as actual key events to the application

It is a way to tell the operating system where it should display intermediate characters in certain composition modii for input methods which usually precompose characters before they are actually sent to the application. (At least for the ImmX11 usage)

From the link below, it seems to be the case for certain Asian keyboards:
http://menehune.opt.wfu.edu/Kokua/Irix_6.5.21_doc_cd/usr/share/Insight/library/SGI_bookshelves/SGI_Developer/books/XLib_PG/sgi_html/ch11.html
(Sections "Issues of Internationalized Text Input" and "User Interaction with an Input Method" should be sufficient for a brief overview)

On Windows, the plugin is not provided in the shipped VM's, and its current whereabouts are uncertain.

On Unix, the only implemented behaviour is setting the position when over-the-spot precomposition of characters is the current mode.

In the VM, the mode is chosen to the first available valid mode returned by the X Server, so whether this is actually relevant at all depends on the X Server.!

!ImmAbstractPlatform methodsFor: 'all' stamp: 'yo 11/7/2002 17:43'!
keyboardFocusForAMorph: aMorph

	"do nothing"
! !

ImmAbstractPlatform subclass: #ImmWin32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-ImmPlugin'!

!ImmWin32 commentStamp: 'LaurentLaffont 3/15/2011 20:48' prior: 0!
See ImmAbstractPlatform!

!ImmWin32 methodsFor: 'as yet unclassified' stamp: 'yo 11/7/2002 16:47'!
setCompositionWindowPositionX: x y: y

	<primitive: 'primSetCompositionWindowPosition' module: 'ImmWin32Plugin'>

	^ nil
! !

ImmAbstractPlatform subclass: #ImmX11
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-ImmPlugin'!

!ImmX11 commentStamp: 'LaurentLaffont 3/15/2011 20:48' prior: 0!
See ImmAbstractPlatform!

Object subclass: #X11Encoding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-ImmPlugin'!

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'sd 2/4/2008 21:21'!
encoding

	| enc |
	enc := self getEncoding.
	enc ifNil: [ ^ nil ].
	^ enc asLowercase.! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'Tsutomu Hiroshima 12/5/2003 15:09'!
getEncoding
	<primitive: 'primGetEncoding' module: 'ImmX11Plugin'>
	^ nil
! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'Tsutomu Hiroshima 12/5/2003 15:07'!
getLocaleEncoding
	<primitive: 'primGetLocaleEncoding' module: 'ImmX11Plugin'>
	^ nil
! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'Tsutomu Hiroshima 12/5/2003 15:07'!
getPathEnc
	<primitive: 'primGetPathEnc' module: 'ImmX11Plugin'>
	^ nil
! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'Tsutomu Hiroshima 12/5/2003 15:07'!
getTextEnc
	<primitive: 'primGetTextEnc' module: 'ImmX11Plugin'>
	^ nil
! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'Tsutomu Hiroshima 12/5/2003 15:07'!
getXWinEnc
	<primitive: 'primGetXWinEnc' module: 'ImmX11Plugin'>
	^ nil
! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'Tsutomu Hiroshima 12/5/2003 15:07'!
requestUTF8
	<primitive: 'primIsTextEncUTF8' module: 'ImmX11Plugin'>
	^ nil
! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'Tsutomu Hiroshima 12/5/2003 15:07'!
requestUTF8: bool
	<primitive: 'primSetTextEncUTF8' module: 'ImmX11Plugin'>
	^ nil
! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'Tsutomu Hiroshima 12/5/2003 15:07'!
setEncoding: encoding
	<primitive: 'primSetEncoding' module: 'ImmX11Plugin'>
	^ nil
! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'Tsutomu Hiroshima 12/5/2003 15:07'!
setEncodingToLocale
	<primitive: 'primSetEncodingToLocale' module: 'ImmX11Plugin'>
	^ nil
! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'Tsutomu Hiroshima 12/5/2003 15:07'!
setPathEnc: encoding
	<primitive: 'primSetPathEnc' module: 'ImmX11Plugin'>
	^ nil
! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'Tsutomu Hiroshima 12/5/2003 15:07'!
setPathEncToLocale
	<primitive: 'primSetPathEncToLocale' module: 'ImmX11Plugin'>
	^ nil
! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'Tsutomu Hiroshima 12/5/2003 15:07'!
setTextEnc: encoding
	<primitive: 'primSetTextEnc' module: 'ImmX11Plugin'>
	^ nil
! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'Tsutomu Hiroshima 12/5/2003 15:07'!
setTextEncToLocale
	<primitive: 'primSetTextEncToLocale' module: 'ImmX11Plugin'>
	^ nil
! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'Tsutomu Hiroshima 12/5/2003 15:07'!
setXWinEnc: encoding
	<primitive: 'primSetXWinEnc' module: 'ImmX11Plugin'>
	^ nil
! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'Tsutomu Hiroshima 12/5/2003 15:07'!
setXWinEncToLocale
	<primitive: 'primSetXWinEncToLocale' module: 'ImmX11Plugin'>
	^ nil
! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'mir 7/15/2004 18:57'!
useEncoding: encoding

	self setEncoding: encoding.
	LanguageEnvironment startUp.
	^ self encoding.! !

!X11Encoding class methodsFor: 'as yet unclassified' stamp: 'mir 7/15/2004 18:57'!
useLocaleEncoding

	self setEncodingToLocale.
	LanguageEnvironment startUp.
	^ self encoding.! !
